# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""Inherit account_invoice_tax to add header discount and early payment discount treatment"""

from osv import osv, fields
from tools.translate import _
import decimal_precision as dp
import time

class account_invoice_tax(osv.osv):
    _inherit = "account.invoice.tax"

    def compute(self, cr, uid, invoice_id, context=None):
        cur_obj = self.pool.get('res.currency')
        inv = self.pool.get('account.invoice').browse(cr, uid, invoice_id, context=context)
        tax_grouped = super(account_invoice_tax, self).compute(cr, uid, invoice_id, context)
        f = 1 - ((inv.header_discount + inv.early_payment_discount or 0) / 100)
        for t in tax_grouped.values():
            t['base'] = cur_obj.round(cr, uid, inv.currency_id, t['base'] * f)
            t['amount'] = cur_obj.round(cr, uid, inv.currency_id, t['amount'] * f)
            t['base_amount'] = cur_obj.round(cr, uid, inv.currency_id, t['base_amount'] * f)
            t['tax_amount'] = cur_obj.round(cr, uid, inv.currency_id, t['tax_amount'] * f)
        return tax_grouped

account_invoice_tax()