# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""Add a new property for early payment discount account by default"""

from osv import osv, fields

class account_journal(osv.osv):
	"""Add a new property for header and early payment discount account by default"""

	_inherit = 'account.journal'

	_columns = {
		'default_early_payment_discount_account_id': fields.many2one('account.account', 'Early Payment Discount Account', help="It acts as a default account for early payment discount amount"),
	}

account_journal()