# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler

class purchase_tickets(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(purchase_tickets, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'get_packages': self.get_packages,
            'get_tickets8': self.get_tickets8,
        })
        user = self.pool.get('res.users').browse(cr, uid, uid)
        self.company = user.company_id
        self.context = context
    
    def get_packages(self, obj):
        context = self.context.copy()
        pool = pooler.get_pool(self.cr.dbname)
        
        result = []
        num_packages = obj.number_of_packages
        if num_packages <= 0:
            num_packages = 1
        for i in range(1, num_packages+1):
            result.append({'num_package': i, 'total_packages': num_packages });
        return result
    
    
    def get_tickets8(self):
       context = self.context.copy()
       pool = pooler.get_pool(self.cr.dbname)
       
       result = []
       diccionario = {}
       j = 0
        
       for a in context['active_ids']:
           obj = self.pool.get("stock.picking").browse(self.cr, self.uid, a)
       
           for line in obj.move_lines:
               cantidad = int(line.product_uos_qty)
               for i in range(cantidad):
                   j = j +1
                   dic = {} 
                   dic['articulo_referencia'] = line.product_id.default_code
                   dic['articulo_nombre1'] = ""
                   dic['articulo_nombre2'] = ""  
                   
                   index = line.name.find("]")
                   cadena = line.name[index+2:]
                   index = 0
                   
                   if len(cadena) >= 40:
                       index = 39
                   if len(cadena) > 40:
                    	while (index < len(cadena)) and cadena[index] != " ":
                    		index +=1
                    	if index > len(cadena):
                    		index = len(cadena) - 1
                    	dic['articulo_nombre1'] =  cadena[0:index]
                   else:
                    	dic['articulo_nombre1'] = cadena
                    
                    
                   if len(dic['articulo_nombre1']) < len(cadena): 
                    	index = 0
                    	if len(cadena) >= 40:
                    		index = 39
                    	if len(cadena) > 40:
                    		while cadena[index] != " ":
                    			index +=1
                    		dic['articulo_nombre2'] = cadena[index+1:]
    
                   pedidos = str(line.origin).split(":")
                   
                   dic['sale_purchase'] = pedidos[0]
                   dic['sale_order'] = ""
                   string_date = str(obj.date)
                   dic['date_order'] = string_date[8:10] + "/" + string_date[5:7] + "/" + string_date[0:4]
                   dic['partner'] = ""
                   if len(pedidos)>1:
                       pedidos_venta = str(pedidos[1]).split(" ")
                       dic['sale_order'] = pedidos_venta[0]
                   
                       sale = self.pool.get("sale.order").search(self.cr, self.uid, [("name", "=", pedidos_venta[0])])
                   
                       if len(sale)> 0:
                         sale = self.pool.get("sale.order").browse(self.cr, self.uid, sale[0])  
                         if sale.partner_ref:
                             old_uid = self.uid
                             self.uid = 1
                             partner = self.pool.get("res.partner").search(self.cr, self.uid, [("ref", "=", sale.partner_ref),("company_id", "=", 4)])
                             partner = self.pool.get("res.partner").browse(self.cr, self.uid, partner[0])
                             dic['partner'] = unicode(partner.name).upper()
                             dic['partner'] = dic['partner'][0:30]
                             self.uid = old_uid
                         else:
                             dic['partner'] = unicode(sale.partner_order_id.partner_id.name).upper()
                             dic['partner'] = dic['partner'][0:30]
                          
                   
                   diccionario['ticket'+str(j)] = dic
                   if j == 8:
                       result.append(diccionario)
                       diccionario = {}
                       j = 0
       if len(diccionario)>0:
           result.append(diccionario)
       return result   
    
        
report_sxw.report_sxw('report.stock.picking.tickets','stock.picking','addons/dos_impacto_purchase_tickets/report/purchase_tickets.rml',parser=purchase_tickets)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
