# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class res_partner(osv.osv):
	_name = "res.partner"
	_description = "Sale agent sale info"
	_inherit = "res.partner"
	
	def _check_permissions(self, cr, uid, ids, field_name, arg, context):
		res = {}

		for i in ids:
			if not i:
				continue

			# Get the HR Officer/Manager id's
			group_obj = self.pool.get('res.groups')
			manager_ids = group_obj.search(cr, uid, [('name','=', 'Sales / Manager')])
			# Get the user and see what groups he/she is in
			user_obj = self.pool.get('res.users')
			user = user_obj.browse(cr, uid, uid, context=context)

			group_ids = []
			for grp in user.groups_id:
				group_ids.append(grp.id)

			if (manager_ids[0] in group_ids):
				res[i] ='Manager'
			else:
				res[i] = 'User'
			
		return res
   
	_columns = {
			'agent_id': fields.many2one('sale.agent','Sales Agent'),
			'unique_commission': fields.float('Unique Comm %'),
			'unique_commission_2': fields.float('Unique Comm 2 %'),
			'is_agent': fields.boolean('Agent'),
			'permissions': fields.function(_check_permissions, type='char', method=True, string="Permissions"),
		}

res_partner()

class res_partner_address(osv.osv):
	_name = "res.partner.address"
	_description = "Sale agent sale info"
	_inherit = "res.partner.address"
	
	_columns = {
		'agent_id': fields.many2one('sale.agent','Sales Agent'),
		}
res_partner_address()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
