# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class sale_agent(osv.osv):
	_name = "sale.agent"
	_description = "Sale agent sale info"
	_columns = {
	    'name': fields.char('Saleagent Name', size=25, required=True),
	    'active': fields.boolean('Active'),
	    'partner_id': fields.many2one('res.partner','Partner',required=True,ondelete='cascade'),
        'commission_rate': fields.float('Commission Rate',required=False),
	    'commissiontozeroforce': fields.boolean('Commission To Zero Force'),
        'retention': fields.float('Retention',required=False),		
	    'commissionwithouttable': fields.boolean('Commission Without Table'),			
	    'commissiontable_id': fields.many2one('sale.commissiontable','Commission Table',required=False),
	    'zone_id': fields.many2one('sale.zone','Zone',required=False),		
	    'customer': fields.one2many('res.partner','agent_id','Customer'),
		'company_id': fields.many2one('res.company', 'Company', required=False),
        }
	_defaults = {
		'active': lambda *a: True,
		'company_id': lambda s, cr, uid, c: s.pool.get('res.company')._company_default_get(cr, uid, 'sale.shop', context=c),
		}

sale_agent()

