# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2010 Tiny SPRL (http://tiny.be). All Rights Reserved
#    
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv
from osv import fields

class sale_commissiontable(osv.osv): 
 
	_name = 'sale.commissiontable'
	_description = 'Commission Table Info'
 
	_columns = {
		'name':fields.char('Name', size=64),
		'maxdctpercent': fields.float('Max Discount %'),
		'maxdctcommission': fields.float('Max Discount Commission'),
		'commissiondctzero': fields.float('Commission for 0% discount'),
		'dctbypaymentdelay': fields.float('% Discount every 30 days'),
		'sale_commissionlines': fields.one2many('sale.commissionlines','sale_commissiontable_id','Líneas'),
		'company_id': fields.many2one('res.company', 'Company', required=False),
		}
	_defaults = {
		'company_id': lambda s, cr, uid, c: s.pool.get('res.company')._company_default_get(cr, uid, 'sale.shop', context=c),
		}
	
sale_commissiontable()
