# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

"""Modificamos el albaran para que al generar la factura herede el representante del cliente"""

from osv import osv

class stock_picking(osv.osv):
	"""Inherit stock_picking to add agent from partner"""

	_inherit = "stock.picking"

	def _invoice_hook(self, cursor, user, picking, invoice_id):
		if picking and picking.partner_id and invoice_id:
			self.pool.get('account.invoice').write(cursor, user, invoice_id, {
					'agent_id': (picking.sale_id and picking.sale_id.agent_id and picking.sale_id.agent_id.id)  or False,
					'agent2_id': (picking.sale_id and picking.sale_id.agent2_id and picking.sale_id.agent2_id.id) or False,
					'agent2_percentage_distribution_commission': picking.sale_id and picking.sale_id.agent2_percentage_distribution_commission or 0.0
				})
			
		return super(stock_picking, self)._invoice_hook(cursor, user, picking, invoice_id)

stock_picking()