# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from osv import osv, fields
from datetime import datetime
from dateutil.relativedelta import relativedelta
from tools.translate import _

class dos_sale_agent_report_wizard(osv.osv_memory):
	_name = 'dos.sale.agent.report.wizard'
	_description = 'Sale Agents Report'
	
	def _get_first_day_present_year(self, cr, uid, context=None):
		if context is None:
			context = {}
		date_ref = datetime.now().strftime('%Y-%m-%d')
		first_date = (datetime.strptime(date_ref, '%Y-%m-%d') + relativedelta(day=1, month=1))
		return first_date.strftime('%Y-%m-%d')
		# return datetime.now()
	
	_columns = {
		'date_start': fields.date('From invoice Date', required=True),
		'date_end': fields.date('To invoice Date', required=True),
		'agent': fields.char('Sales Agent', size=64),
	}
	
	_defaults = {
		'date_start': _get_first_day_present_year,
		'date_end': time.strftime('%Y-%m-%d'),
	}
	
	def check_report(self, cr, uid, ids, context=None):
		datas = {}
		if context is None:
			context = {}
		
		data = self.read(cr, uid, ids, [], context=context)[0]
		
		context['data_report'] = data
		
		datas = {
			 'ids': context.get('active_ids',[]),
			 'model': 'sale.agent',
			 'form': data,
			 'context': context
		}

		return {
			'type': 'ir.actions.report.xml',
			'report_name': 'sale_agent_report',
			'context': context,
			'datas': datas,
		}

			
dos_sale_agent_report_wizard()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: