# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from lxml import etree
import decimal_precision as dp

import netsvc
import pooler
from osv import fields, osv, orm
from tools.translate import _

class account_invoice(osv.osv):

    _name = "account.invoice"
    _inherit = "account.invoice"

    def unlink(self, cr, uid, ids, context=None):
        #TODO: process before delete resource
        
        for id in ids:
            invoice = self.pool.get("account.invoice").browse(cr, uid, id)
            
            cr.execute("SELECT picking_id from picking_invoice_rel where invoice_id = %s", (str(id),))
            result_select = cr.fetchall()
            if len(result_select) > 0:
                for result in result_select:
                    albaran= self.pool.get("stock.picking").browse(cr, uid, int(result[0]))
                    if albaran and albaran.invoice_state == "invoiced":
                        self.pool.get("stock.picking").write(cr, uid, [albaran.id], {'invoice_state': "2binvoiced"})
                                            
        res = super(account_invoice, self).unlink(cr, uid, ids, context)
        return res 

   

account_invoice()

class stock_picking(osv.osv):
    _inherit = 'stock.picking'

    _columns = {
        'invoice_ids': fields.many2many('account.invoice', 'picking_invoice_rel', 'picking_id', 'invoice_id', 'Invoices', domain=[('type', '=', 'out_invoice')]),
    }

    def action_invoice_create(self, cr, uid, ids, journal_id=False,
            group=False, type='out_invoice', context=None):
        # need to carify with new requirement
        invoices_ids_aux = []
                
        if context is None:
            context = {}
        picking_obj = self.pool.get('stock.picking')
        res = super(stock_picking, self).action_invoice_create(cr, uid, ids, journal_id=journal_id,group=group, type=type, context=context)        
        invoices_ids_aux = res.values()
        
        for id in invoices_ids_aux:
            invoice_ids = [] 
            pickings = []  
            if id not in invoice_ids:
                invoice_ids.append(id)
                for r in res:
                    if res[r] == id:
                        pickings.append(r)
                picking_obj.write(cr, uid, pickings, {'invoice_ids': [[6, 0, invoice_ids]]})
        return res

stock_picking()



# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
